import { selectProps as O, setupSelect as U, setupCron as V, cronCoreProps as B } from "@vue-js-cron/core";
import { NButton as S, NPopover as j, NGrid as E, NGridItem as I, NTag as A, NIcon as G } from "naive-ui";
import { defineComponent as h, openBlock as d, createElementBlock as u, createElementVNode as b, ref as M, resolveComponent as l, createVNode as r, mergeProps as w, withCtx as s, createSlots as T, createTextVNode as p, toDisplayString as c, withModifiers as z, Fragment as g, renderList as C, createBlock as D } from "vue";
const F = {
  xmlns: "http://www.w3.org/2000/svg",
  "xmlns:xlink": "http://www.w3.org/1999/xlink",
  viewBox: "0 0 512 512"
}, L = /* @__PURE__ */ b(
  "path",
  {
    d: "M289.94 256l95-95A24 24 0 0 0 351 127l-95 95l-95-95a24 24 0 0 0-34 34l95 95l-95 95a24 24 0 1 0 34 34l95-95l95 95a24 24 0 0 0 34-34z",
    fill: "currentColor"
  },
  null,
  -1
  /* HOISTED */
), q = [L], H = h({
  name: "Close",
  render: function(o, n) {
    return d(), u("svg", F, q);
  }
}), J = h({
  inheritAttrs: !1,
  name: "CustomSelect",
  components: {
    NButton: S,
    NPopover: j,
    NGrid: E,
    NGridItem: I,
    NTag: A,
    NIcon: G,
    Close: H
  },
  props: {
    ...O(),
    buttonProps: {
      type: Object,
      default: () => {
      }
    },
    popoverProps: {
      type: Object,
      default: () => {
      }
    },
    hideOnClick: {
      type: Boolean,
      default: !0
    }
  },
  emits: ["update:model-value"],
  setup(e, o) {
    const n = U(e, () => e.modelValue, o), a = M(!1);
    return {
      ...n,
      show: a,
      select: (_) => {
        n.select(_), e.hideOnClick && (a.value = !1);
      }
    };
  }
});
const k = (e, o) => {
  const n = e.__vccOpts || e;
  for (const [a, m] of o)
    n[a] = m;
  return n;
};
function K(e, o, n, a, m, _) {
  const v = l("close"), t = l("n-icon"), f = l("n-button"), y = l("n-tag"), N = l("n-grid-item"), P = l("n-grid"), $ = l("n-popover");
  return d(), u("span", null, [
    r($, w({
      show: e.show,
      "onUpdate:show": o[1] || (o[1] = (i) => e.show = i),
      trigger: "click"
    }, e.popoverProps, { disabled: e.disabled }), {
      trigger: s(() => [
        r(f, w(e.buttonProps, {
          "icon-placement": "right",
          disabled: e.disabled
        }), T({
          default: s(() => [
            p(c(e.selection ?? e.selectedStr) + " ", 1)
          ]),
          _: 2
        }, [
          e.clearable && !e.isEmpty ? {
            name: "icon",
            fn: s(() => [
              r(t, {
                onClick: [
                  e.clear,
                  o[0] || (o[0] = z(() => {
                  }, ["stop"]))
                ]
              }, {
                default: s(() => [
                  r(v)
                ]),
                _: 1
              }, 8, ["onClick"])
            ]),
            key: "0"
          } : void 0
        ]), 1040, ["disabled"])
      ]),
      default: s(() => [
        r(P, {
          class: "vcron-n-grid",
          cols: e.cols
        }, {
          default: s(() => [
            (d(!0), u(g, null, C(e.items, (i) => (d(), D(N, {
              key: i.vaue
            }, {
              default: s(() => [
                r(y, {
                  checked: e.has(i),
                  onUpdateChecked: (ee) => e.select(i),
                  checkable: ""
                }, {
                  default: s(() => [
                    p(c(i.text), 1)
                  ]),
                  _: 2
                }, 1032, ["checked", "onUpdateChecked"])
              ]),
              _: 2
            }, 1024))), 128))
          ]),
          _: 1
        }, 8, ["cols"])
      ]),
      _: 1
    }, 16, ["show", "disabled"])
  ]);
}
const Q = /* @__PURE__ */ k(J, [["render", K], ["__scopeId", "data-v-f7c78d80"]]), R = () => ({
  /**
   * Properties of Naive UI Button
   *
   * @remarks
   * See {@link https://www.naiveui.com/en-US/os-theme/components/button#Button-Props}
   */
  buttonProps: {
    type: Object,
    default() {
      return {};
    }
  },
  /**
   * Properties of Naive UI Popover
   *
   * @remarks
   * See {@link https://www.naiveui.com/en-US/os-theme/components/popover#Popover-Props}
   */
  dropdownProps: {
    type: Object,
    default: () => {
    }
  },
  ...B()
}), W = h({
  name: "CronNaive",
  components: {
    CustomSelect: Q
  },
  props: R(),
  emits: ["update:model-value", "update:period", "error"],
  setup(e, o) {
    return V(e, o);
  }
});
const X = { class: "vcron-n-spacer" }, Y = { class: "vcron-n-spacer" };
function Z(e, o, n, a, m, _) {
  const v = l("custom-select");
  return d(), u("div", null, [
    p(c(e.period.prefix.value) + " ", 1),
    b("div", X, [
      r(v, {
        "model-value": e.period.selected.value.id,
        "item-value": "id",
        items: e.period.items,
        "onUpdate:modelValue": o[0] || (o[0] = (t) => e.period.select(t)),
        disabled: e.disabled,
        "button-props": e.buttonProps
      }, null, 8, ["model-value", "items", "disabled", "button-props"])
    ]),
    p(" " + c(e.period.suffix.value) + " ", 1),
    (d(!0), u(g, null, C(e.selected, (t) => (d(), u(g, {
      key: t.id
    }, [
      p(c(t.prefix.value) + " ", 1),
      b("div", Y, [
        r(v, {
          "model-value": t.selected.value,
          "onUpdate:modelValue": (f) => t.select(f),
          items: t.items,
          cols: e.cols[t.id] || 1,
          selection: t.text.value,
          multiple: "",
          clearable: "",
          disabled: e.disabled,
          "button-props": e.buttonProps,
          "dropdown-props": e.dropdownProps,
          hideOnClick: !1
        }, null, 8, ["model-value", "onUpdate:modelValue", "items", "cols", "selection", "disabled", "button-props", "dropdown-props"])
      ]),
      p(" " + c(t.suffix.value), 1)
    ], 64))), 128))
  ]);
}
const x = /* @__PURE__ */ k(W, [["render", Z]]), se = {
  install: (e) => {
    e.component("CronNaive", x);
  }
};
export {
  x as CronNaive,
  se as CronNaivePlugin,
  R as cronNaiveProps,
  se as default
};
//# sourceMappingURL=naive-ui.js.map
